Unit qsh4e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTQS12_p;

procedure qsh4e(var RINT :Extended; var A :Array of Extended;
                var B :Array of Extended; F :Func_F1AE; E :Extended;
                var IERR :Integer);

implementation

procedure qsh4e(var RINT :Extended; var A :Array of Extended;
                var B :Array of Extended; F :Func_F1AE; E :Extended;
                var IERR :Integer);
var
I,J,JR,K,K1,M :Integer;
E1,R,S,S1,S2,V,Z,Z1 :Extended;
IE :Array [0..79] of Integer;
IQ :Array [0..3] of Integer;
IR :Array [0..3] of Integer;
X :Array [0..3] of Extended;
X1 :Array [0..3] of Extended;
Y :Array [0..79] of Extended;
Y1 :Array [0..79] of Extended;
const
N :Integer = 20000;
N2 :Integer = 2000000000;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140;
begin
{    4-     }
IERR := 0;
IR[0] := 3;
IR[1] := 5;
IR[2] := 7;
IR[3] := 11;
Z1 := 1.e0;
for I:=1 to 4 do
 begin
  Z1 := (B[I-1] - A[I-1])*Z1;
_10:
 end;
E1 := 1.e0/Z1;
S := 0.e0;
S1 := 0.e0;
I := 1;
for M:=1 to 4 do
 begin
  IQ[M-1] := 1;
  IE[0+(M-1)*20] := 0;
  X1[M-1] := 0;
  X[M-1] := A[M-1];
  R := 1.e0/IR[M-1];
  Z := R;
  for J:=1 to 20 do
   begin
    Y[(J-1)+(M-1)*20] := -1.e0 + R*(1 + IR[M-1]);
    Y1[(J-1)+(M-1)*20] := R;
    R := R*Z;
_20:
   end;
_30:
 end;
_40:
I := I + 1;
S := S + F(X);
if ( I - N ) < 0
 then goto _50
 else if ( I - N ) > 0
       then goto _110
       else goto _50;
_50:
for M:=1 to 4 do
 begin
  K1 := IQ[M-1];
  JR := IR[M-1];
  for K:=1 to K1 do
   begin
    IE[(K-1)+(M-1)*20] := IE[(K-1)+(M-1)*20] + 1;
    if ( IE[(K-1)+(M-1)*20] - JR ) < 0
     then goto _80
     else if ( IE[(K-1)+(M-1)*20] - JR ) > 0
           then goto _60
           else goto _60;
_60:
    IE[(K-1)+(M-1)*20] := 0;
_70:
   end;
  K := K1 + 1;
  IQ[M-1] := K;
  IE[(K-1)+(M-1)*20] := 1;
  X1[M-1] := Y1[(K-1)+(M-1)*20];
  goto _90;
_80:
  X1[M-1] := X1[M-1] + Y[(K-1)+(M-1)*20];
_90:
  X[M-1] := A[M-1] + (B[M-1] - A[M-1])*X1[M-1];
_100:
 end;
goto _40;
_110:
S2 := S;
S := S/N;
V := Abs(S-S1);
if ( V - E*(E1 + Abs(S)) ) < 0
 then goto _140
 else if ( V - E*(E1 + Abs(S)) ) > 0
       then goto _120
       else goto _140;
_120:
S1 := S;
S := S2;
N := 2*N;
if ( N - N2 ) < 0
 then goto _50
 else if ( N - N2 ) > 0
       then goto _130
       else goto _130;
_130:
IERR := 65;
S := S/N;
UTQS12(IERR,12);
_140:
RINT := S*Z1;
end;

end.
